##################################
# 表示するか否か
# "-DshowIBAction" actionのコネクションを表示する
# "-DshowIBOutlet" outletのコネクションを表示する
##################################
#define(showIBOutlet)
#define(showIBAction)


##################################
# コネクションマクロ
##################################

# action コネクションマクロ
# IBAction(接続元、接続先、ラベル)
define(`IBAction',`$1 -> $2[label = $3, ifdef(`showIBAction', style=solid, style=invis)]')

# outletコネクションマクロ
# IBOutlet(接続元、接続先、ラベル)
define(`IBOutlet',`$1 -> $2[label = $3, ifdef(`showIBOutlet', style=solid, style=invis), ifelse(def_cluster__$2__, YES,lhead= cluster_$2,)]')


##################################
# アイコンの表示のノード
##################################
# icon
define(`ICON', `$1 [ label = <<TABLE cellpadding="0" border="0" cellborder="0"><TR><TD><IMG SRC="icon/$2.png"/></TD></TR><TR><TD>ifelse($3,`',$1,$3)</TD></TR></TABLE>>, group = "$4"]
ifelse(isInsideLocalContainerView, YES,`LocalContainerViewNodeName -> $1[style=invis]', `')
')


##################################
# View階層を示すコンテナーView
##################################
define(`BeginContainerView', `
subgraph cluster_$1 {
$1 [ label = <<TABLE cellpadding="0" border="0" cellborder="0"><TR><TD><IMG SRC="icon/$2.png"/></TD></TR><TR><TD>ifelse($3,`',$1,$3)</TD></TR></TABLE>>, fillcolor=none, group = "$4"];

define(def_cluster__$1__, YES)

# コンテナの中であるとのフラグを立てる。
pushdef(`SuperContainerViewNodeName', LocalContainerViewNodeName)
pushdef(`LocalContainerViewNodeName', $1)
pushdef(`isInsideLocalContainerView', `YES')
')

define(`EndContainerView', `
}
popdef(`isInsideLocalContainerView')
ifelse(isInsideLocalContainerView, YES,`SuperContainerViewNodeName -> LocalContainerViewNodeName[style=invis]', `')
popdef(`SuperContainerViewNodeName')
popdef(`LocalContainerViewNodeName')
')


##################################
# 省略表記
##################################

# NSApplicationオブジェクトを配置する
define(`ApplicationObject', `ICON($1, NSApplication, $2, $3)')

# 一般オブジェクトを配置する
define(`GenericObject', `ICON($1, NSObject, $2, $3)')

# Windowオブジェクトを配置する
define(`WindowObject', `ICON($1, NSWindow, $2, $3)')

# コントロールオブジェクト
define(`ControlObject', `ICON($1, NSControl, $2, $3)')

# 一般ViewObject
define(`GenericViewObject', `ICON($1, NSView, $2, $3)')


##################################
# 初期設定
##################################

graph [
compound = true;
newrank=true;
// bgcolor="#00000000";// 背景を透明にする
shape=box;
style="rounded";
color= gray;
penwidth=3.0;
fontname = "Courier";
labelloc=t;
fixedsize = false;
];

node [
shape=box,
style="filled, rounded",
fillcolor=gray
color=none
fontname = "Courier"
labelloc=m
imagescale=true
fixedsize = true,  width = 1.8, height = 1.4
]

edge [
arrowtail = dot,
dir = both,
fontname = "Courier"
style = "bold"
]
